#include <bnl/utility/error.hpp>

namespace bnl
{

io_error::io_error(const ::std::string& msg)
    : runtime_error(msg)
{
}

io_error::io_error(const char* msg)
    : runtime_error(msg)
{
}

smile_error::smile_error(::DSL_errorStringHandler& error_handler, const ::std::string& msg)
    : runtime_error((error_handler.GetNumberOfErrors() > 0)
                    ? error_handler.GetLastErrorMessage() : msg)
{
}

smile_error::smile_error(::DSL_errorStringHandler& error_handler, const char* msg)
    : runtime_error((error_handler.GetNumberOfErrors() > 0)
                    ? error_handler.GetLastErrorMessage() : msg)
{
}

match_error::match_error(const ::std::string& msg)
    : runtime_error(msg)
{
}

match_error::match_error(const char* msg)
    : runtime_error(msg)
{
}

} // namespace bnl
