#include <bnl/random/randgen.hpp>
#include <ctime>

namespace bnl
{
namespace random
{

urng_type& global_urng()
{
#ifndef NDEBUG
    static urng_type urng;
#else
    static urng_type urng(static_cast<unsigned>(::std::time(0)));
#endif
    return urng;
}

rng_type& global_rng()
{
    static rng_type rng((global_urng()));
    return rng;
}

double random_real(double min_arg, double max_arg)
{
    assert(min_arg <= max_arg);
    return uniform_real_distribution(min_arg, max_arg)(global_urng());
}

int random_int(int min_arg, int max_arg)
{
    assert(min_arg <= max_arg);
    return uniform_int_distribution(min_arg, max_arg)(global_urng());
}

bool random_bool()
{
    return random_int(0, 1) != 0;
}

} // namespace random
} // namespace bnl

