#include <boost/graph/graphviz.hpp>
#include <graphviz.hpp>
#include <PrintXDSL.hpp>
#include <string>
#include <fstream>
#include <iterator>
#include <iostream>
#include <utility>
#include <limits>
#include <iomanip>

#include <smile/smile.h>
#include <smile/smilearn.h>
using namespace std;


void test_gviz_to_genie()
{
     cout << "Assumes dataset is stored in [Dataset.txt]" << endl;
     cout << "and dot file is stored in [InputFile.dot]" << endl;
     cout << "Resulted xdsl file is stored in [output.xdsl]" << endl;
     fflush(stdout);

    std::ifstream in("InputFile.dot");
    bnl::bayesian_network bn = bnl::read_graphviz(in);
    DSL_dataset ds;
	if (ds.ReadFile("Dataset.txt") != DSL_OKAY) 
	{
     std::cout << "Cannot read data file: [Dataset.txt] ... exiting." << std::endl;
     exit(1);
	}
	std::vector<DSL_datasetMatch> matches;
	std::string err;
	if (ds.MatchNetwork(bn, matches, err) != DSL_OKAY) 
	{
     std::cout << "Cannot match network... exiting." << std::endl;
     exit(1);
	}
    DSL_em em;
	if (em.Learn(ds, bn, matches) != DSL_OKAY) 
	{
     std::cout << "Cannot learn parameters... exiting." << std::endl;
     exit(1);
	}
    bn.write_file("output.xdsl");
}

int main()
{
	
	test_gviz_to_genie();

}
